hack/make.sh
b1953bab
 #!/usr/bin/env bash
83a2e92d
 set -e
89ee5242
 
d9f76993
 # This script builds various binary artifacts from a checkout of the docker
 # source code.
89ee5242
 #
 # Requirements:
d9f76993
 # - The current directory should be a checkout of the docker source code
723d4338
 #   (https://github.com/docker/docker). Whatever version is checked out
d9f76993
 #   will be built.
 # - The VERSION file, at the root of the repository, should exist, and
 #   will be used as Docker binary version and package version.
 # - The hash of the git commit will also be included in the Docker binary,
a8059059
 #   with the suffix -dirty if the repository isn't clean.
d14058bc
 # - The script is intented to be run inside the docker container specified
d9f76993
 #   in the Dockerfile at the root of the source. In other words:
 #   DO NOT CALL THIS SCRIPT DIRECTLY.
83d81758
 # - The right way to call this script is to invoke "make" from
b3d5e952
 #   your checkout of the Docker repository.
2a1181f4
 #   the Makefile will do a "docker build -t docker ." and then
a0505edc
 #   "docker run hack/make.sh" in the resulting image.
aa3de0b8
 #
89ee5242
 
83a2e92d
 set -o pipefail
89ee5242
 
3a14eb06
 export DOCKER_PKG='github.com/docker/docker'
23afce5f
 export SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
6533cb97
 export MAKEDIR="$SCRIPTDIR/make"
3a14eb06
 
749a7d0e
 # We're a nice, sexy, little shell script, and people might try to run us;
 # but really, they shouldn't. We want to be in a container!
6f812a4e
 if [ "$PWD" != "/go/src/$DOCKER_PKG" ] || [ -z "$DOCKER_CROSSPLATFORMS" ]; then
b994c131
 	{
 		echo "# WARNING! I don't seem to be running in the Docker container."
 		echo "# The result of this command might be an incorrect build, and will not be"
 		echo "#   officially supported."
 		echo "#"
 		echo "# Try this instead: make all"
 		echo "#"
 	} >&2
 fi
 
 echo
749a7d0e
 
3d39336a
 # List of bundles to create when no argument is passed
 DEFAULT_BUNDLES=(
81370b5b
 	validate-dco
 	validate-gofmt
bc8b8e03
 	validate-lint
9465272c
 	validate-pkg
ecccfa82
 	validate-test
d245a8a7
 	validate-toml
3280ce65
 	validate-vet
3a138570
 
3d39336a
 	binary
3a138570
 
a39f3c92
 	test-unit
2543912e
 	test-integration-cli
100267de
 	test-docker-py
3a138570
 
21161dbd
 	dynbinary
3a138570
 
59dc2876
 	cover
62a81370
 	cross
b3f5973f
 	tgz
3d39336a
 	ubuntu
 )
 
4d53a195
 VERSION=$(< ./VERSION)
0a040645
 if command -v git &> /dev/null && git rev-parse &> /dev/null; then
efd0e13c
 	GITCOMMIT=$(git rev-parse --short HEAD)
0a040645
 	if [ -n "$(git status --porcelain --untracked-files=no)" ]; then
efd0e13c
 		GITCOMMIT="$GITCOMMIT-dirty"
 	fi
87eae0d6
 	BUILDTIME=$(date -u)
efd0e13c
 elif [ "$DOCKER_GITCOMMIT" ]; then
 	GITCOMMIT="$DOCKER_GITCOMMIT"
 else
 	echo >&2 'error: .git directory missing and DOCKER_GITCOMMIT not specified'
 	echo >&2 '  Please either build with the .git directory accessible, or specify the'
 	echo >&2 '  exact (--short) commit hash you are building using DOCKER_GITCOMMIT for'
 	echo >&2 '  future accountability in diagnosing build issues.  Thanks!'
 	exit 1
5b630d43
 fi
89ee5242
 
d3d85d38
 if [ "$AUTO_GOPATH" ]; then
 	rm -rf .gopath
3a14eb06
 	mkdir -p .gopath/src/"$(dirname "${DOCKER_PKG}")"
 	ln -sf ../../../.. .gopath/src/"${DOCKER_PKG}"
6f812a4e
 	export GOPATH="${PWD}/.gopath:${PWD}/vendor"
d3d85d38
 fi
 
 if [ ! "$GOPATH" ]; then
723d4338
 	echo >&2 'error: missing GOPATH; please see https://golang.org/doc/code.html#GOPATH'
d3d85d38
 	echo >&2 '  alternatively, set AUTO_GOPATH=1'
 	exit 1
 fi
 
ca6722f1
 if [ "$DOCKER_EXPERIMENTAL" ]; then
 	echo >&2 '# WARNING! DOCKER_EXPERIMENTAL is set: building experimental features'
 	echo >&2
 	DOCKER_BUILDTAGS+=" experimental"
 fi
 
1b95590d
 if [ -z "$DOCKER_CLIENTONLY" ]; then
 	DOCKER_BUILDTAGS+=" daemon"
 fi
 
547c9595
 if [ "$DOCKER_EXECDRIVER" = 'lxc' ]; then
 	DOCKER_BUILDTAGS+=' test_no_exec'
 fi
 
3761955e
 # test whether "btrfs/version.h" exists and apply btrfs_noversion appropriately
 if \
 	command -v gcc &> /dev/null \
 	&& ! gcc -E - &> /dev/null <<<'#include <btrfs/version.h>' \
 ; then
 	DOCKER_BUILDTAGS+=' btrfs_noversion'
 fi
 
b3e29926
 # test whether "libdevmapper.h" is new enough to support deferred remove
 # functionality.
 if \
 	command -v gcc &> /dev/null \
 	&& ! ( echo -e  '#include <libdevmapper.h>\nint main() { dm_task_deferred_remove(NULL); }'| gcc -ldevmapper -xc - &> /dev/null ) \
 ; then
        DOCKER_BUILDTAGS+=' libdm_no_deferred_remove'
 fi
 
b187cc40
 # Use these flags when compiling the tests and final binary
bce9ed0e
 
6871b9b1
 IAMSTATIC='true'
23afce5f
 source "$SCRIPTDIR/make/.go-autogen"
a121ac85
 if [ -z "$DOCKER_DEBUG" ]; then
 	LDFLAGS='-w'
 fi
bce9ed0e
 
be344cf0
 LDFLAGS_STATIC='-linkmode external'
ce86d5ae
 # Cgo -H windows is incompatible with -linkmode external.
 if [ "$(go env GOOS)" == 'windows' ]; then
 	LDFLAGS_STATIC=''
 fi
be344cf0
 EXTLDFLAGS_STATIC='-static'
aa129b35
 # ORIG_BUILDFLAGS is necessary for the cross target which cannot always build
 # with options like -race.
232d59ba
 ORIG_BUILDFLAGS=( -a -tags "netgo static_build $DOCKER_BUILDTAGS" -installsuffix netgo )
 # see https://github.com/golang/go/issues/9369#issuecomment-69864440 for why -installsuffix is necessary here
aa129b35
 BUILDFLAGS=( $BUILDFLAGS "${ORIG_BUILDFLAGS[@]}" )
 # Test timeout.
b98edced
 : ${TIMEOUT:=60m}
aa129b35
 TESTFLAGS+=" -test.timeout=${TIMEOUT}"
b187cc40
 
be344cf0
 # A few more flags that are specific just to building a completely-static binary (see hack/make/binary)
 # PLEASE do not use these anywhere else.
 EXTLDFLAGS_STATIC_DOCKER="$EXTLDFLAGS_STATIC -lpthread -Wl,--unresolved-symbols=ignore-in-object-files"
 LDFLAGS_STATIC_DOCKER="
 	$LDFLAGS_STATIC
 	-extldflags \"$EXTLDFLAGS_STATIC_DOCKER\"
 "
 
18bea249
 if [ "$(uname -s)" = 'FreeBSD' ]; then
 	# Tell cgo the compiler is Clang, not GCC
 	# https://code.google.com/p/go/source/browse/src/cmd/cgo/gcc.go?spec=svne77e74371f2340ee08622ce602e9f7b15f29d8d3&r=e6794866ebeba2bf8818b9261b54e2eef1c9e588#752
 	export CC=clang
 
 	# "-extld clang" is a workaround for
 	# https://code.google.com/p/go/issues/detail?id=6845
 	LDFLAGS="$LDFLAGS -extld clang"
 fi
 
92ea101b
 # If sqlite3.h doesn't exist under /usr/include,
 # check /usr/local/include also just in case
 # (e.g. FreeBSD Ports installs it under the directory)
 if [ ! -e /usr/include/sqlite3.h ] && [ -e /usr/local/include/sqlite3.h ]; then
 	export CGO_CFLAGS='-I/usr/local/include'
 	export CGO_LDFLAGS='-L/usr/local/lib'
 fi
 
59dc2876
 HAVE_GO_TEST_COVER=
eddda577
 if \
ad80da33
 	go help testflag | grep -- -cover > /dev/null \
eddda577
 	&& go tool -n cover > /dev/null 2>&1 \
 ; then
59dc2876
 	HAVE_GO_TEST_COVER=1
 fi
 
dcfc4ada
 # If $TESTFLAGS is set in the environment, it is passed as extra arguments to 'go test'.
 # You can use this to select certain tests to run, eg.
 #
987e2216
 #     TESTFLAGS='-test.run ^TestBuild$' ./hack/make.sh test-unit
 #
 # For integration-cli test, we use [gocheck](https://labix.org/gocheck), if you want
 # to run certain tests on your local host, you should run with command:
 #
 #     TESTFLAGS='-check.f DockerSuite.TestBuild*' ./hack/make.sh binary test-integration-cli
dcfc4ada
 #
 go_test_dir() {
 	dir=$1
b3d5e952
 	coverpkg=$2
59dc2876
 	testcover=()
 	if [ "$HAVE_GO_TEST_COVER" ]; then
 		# if our current go install has -cover, we want to use it :)
 		mkdir -p "$DEST/coverprofiles"
 		coverprofile="docker${dir#.}"
ac338836
 		coverprofile="$ABS_DEST/coverprofiles/${coverprofile//\//-}"
b3d5e952
 		testcover=( -cover -coverprofile "$coverprofile" $coverpkg )
59dc2876
 	fi
dcfc4ada
 	(
3a14eb06
 		echo '+ go test' $TESTFLAGS "${DOCKER_PKG}${dir#.}"
dcfc4ada
 		cd "$dir"
ac338836
 		export DEST="$ABS_DEST" # we're in a subshell, so this is safe -- our integration-cli tests need DEST, and "cd" screws it up
ed345fb1
 		test_env go test ${testcover[@]} -ldflags "$LDFLAGS" "${BUILDFLAGS[@]}" $TESTFLAGS
dcfc4ada
 	)
 }
ed345fb1
 test_env() {
 	# use "env -i" to tightly control the environment variables that bleed into the tests
 	env -i \
 		DEST="$DEST" \
 		DOCKER_EXECDRIVER="$DOCKER_EXECDRIVER" \
 		DOCKER_GRAPHDRIVER="$DOCKER_GRAPHDRIVER" \
44de5fec
 		DOCKER_USERLANDPROXY="$DOCKER_USERLANDPROXY" \
ed345fb1
 		DOCKER_HOST="$DOCKER_HOST" \
 		GOPATH="$GOPATH" \
ac338836
 		HOME="$ABS_DEST/fake-HOME" \
ed345fb1
 		PATH="$PATH" \
fba44a7c
 		TEMP="$TEMP" \
ed345fb1
 		TEST_DOCKERINIT_PATH="$TEST_DOCKERINIT_PATH" \
 		"$@"
 }
dcfc4ada
 
d43f0b9f
 # a helper to provide ".exe" when it's appropriate
 binary_extension() {
 	if [ "$(go env GOOS)" = 'windows' ]; then
 		echo -n '.exe'
 	fi
 }
 
b3d5e952
 # This helper function walks the current directory looking for directories
 # holding certain files ($1 parameter), and prints their paths on standard
 # output, one per line.
 find_dirs() {
66baf566
 	find . -not \( \
99b63647
 		\( \
d43f0b9f
 			-path './vendor/*' \
 			-o -path './integration-cli/*' \
 			-o -path './contrib/*' \
 			-o -path './pkg/mflag/example/*' \
 			-o -path './.git/*' \
 			-o -path './bundles/*' \
 			-o -path './docs/*' \
 			-o -path './pkg/libcontainer/nsinit/*' \
99b63647
 		\) \
b3d5e952
 		-prune \
 	\) -name "$1" -print0 | xargs -0n1 dirname | sort -u
 }
 
6b46a091
 hash_files() {
 	while [ $# -gt 0 ]; do
 		f="$1"
 		shift
 		dir="$(dirname "$f")"
 		base="$(basename "$f")"
 		for hashAlgo in md5 sha256; do
 			if command -v "${hashAlgo}sum" &> /dev/null; then
 				(
 					# subshell and cd so that we get output files like:
 					#   $HASH docker-$VERSION
 					# instead of:
 					#   $HASH /go/src/github.com/.../$VERSION/binary/docker-$VERSION
 					cd "$dir"
 					"${hashAlgo}sum" "$base" > "$base.$hashAlgo"
 				)
 			fi
 		done
 	done
 }
 
3d39336a
 bundle() {
ac338836
 	local bundle="$1"; shift
 	echo "---> Making bundle: $(basename "$bundle") (in $DEST)"
 	source "$SCRIPTDIR/make/$bundle" "$@"
89ee5242
 }
 
 main() {
aa3de0b8
 	# We want this to fail if the bundles already exist and cannot be removed.
3d39336a
 	# This is to avoid mixing bundles from different versions of the code.
 	mkdir -p bundles
 	if [ -e "bundles/$VERSION" ]; then
 		echo "bundles/$VERSION already exists. Removing."
ac20568b
 		rm -fr "bundles/$VERSION" && mkdir "bundles/$VERSION" || exit 1
aa3de0b8
 		echo
3d39336a
 	fi
d4275348
 
 	if [ "$(go env GOHOSTOS)" != 'windows' ]; then
 		# Windows and symlinks don't get along well
9e00e340
 
f228fb09
 		rm -f bundles/latest
 		ln -s "$VERSION" bundles/latest
d4275348
 	fi
 
3d39336a
 	if [ $# -lt 1 ]; then
85956c70
 		bundles=(${DEFAULT_BUNDLES[@]})
3d39336a
 	else
 		bundles=($@)
 	fi
 	for bundle in ${bundles[@]}; do
ac338836
 		export DEST="bundles/$VERSION/$(basename "$bundle")"
 		# Cygdrive paths don't play well with go build -o.
 		if [[ "$(uname -s)" == CYGWIN* ]]; then
 			export DEST="$(cygpath -mw "$DEST")"
 		fi
 		mkdir -p "$DEST"
 		ABS_DEST="$(cd "$DEST" && pwd -P)"
 		bundle "$bundle"
aa3de0b8
 		echo
3d39336a
 	done
89ee5242
 }
 
3d39336a
 main "$@"